//
//  FMException.h
//

#import <Foundation/Foundation.h>
#import <Foundation/NSException.h>

// Exeption Codeは、DBで発生したエラーの種類をCodeで表したものです。
typedef enum _DBExceptionCode {
	DB_OPEN_ERROR = 0,
	DB_INSERT_ERROR,
	DB_UPDATE_ERROR,
	DB_DELETE_ERROR,
	DB_SELECT_ERROR,
	DB_PREPARE_ERROR,
	DB_FINALIZE_ERROR
} DBExceptionCode;

@interface DBException : NSException {
	// Exeption Codeを保持するメンバ変数
	DBExceptionCode Code_;
    
	// エラー発生した場所(クラス名/メソッド名)を保持するメンバ変数
	NSString* Method_;
}
@property (nonatomic) DBExceptionCode Code;

-(NSString*)message;
-(NSString*)method;

+(id)exceptionWithCode:(DBExceptionCode) Code
                  Name:(NSString*) Name
                Method:(NSString*) Method;

-(id)initWithCode:(DBExceptionCode) Code
             Name:(NSString*) Name
	       Method:(NSString*) Method;

@end